diff --git a/gnome-session/gsm-manager.c b/gnome-session/gsm-manager.c
index b7f1788e..743a372e 100644
--- a/gnome-session/gsm-manager.c
+++ b/gnome-session/gsm-manager.c
@@ -1986,50 +3254,43 @@ idle_timeout_get_mapping (GValue *value,
 static void
 gsm_manager_init (GsmManager *manager)
 {
-        manager->settings = g_settings_new (GSM_MANAGER_SCHEMA);
-        manager->session_settings = g_settings_new (SESSION_SCHEMA);
-        manager->lockdown_settings = g_settings_new (LOCKDOWN_SCHEMA);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
 
-        manager->clients = gsm_store_new ();
-        g_signal_connect (manager->clients,
-                          "added",
-                          G_CALLBACK (on_store_client_added),
-                          manager);
-        g_signal_connect (manager->clients,
-                          "removed",
-                          G_CALLBACK (on_store_client_removed),
-                          manager);
+        priv->settings = g_settings_new (GSM_MANAGER_SCHEMA);
+        priv->session_settings = g_settings_new (SESSION_SCHEMA);
+        priv->screensaver_settings = g_settings_new (SCREENSAVER_SCHEMA);
+        priv->lockdown_settings = g_settings_new (LOCKDOWN_SCHEMA);
 
-        manager->inhibitors = gsm_store_new ();
-        g_signal_connect (manager->inhibitors,
+        priv->inhibitors = gsm_store_new ();
+        g_signal_connect (priv->inhibitors,
                           "added",
                           G_CALLBACK (on_store_inhibitor_added),
                           manager);
-        g_signal_connect (manager->inhibitors,
+        g_signal_connect (priv->inhibitors,
                           "removed",
                           G_CALLBACK (on_store_inhibitor_removed),
                           manager);
 
-        manager->apps = gsm_store_new ();
+        priv->apps = gsm_store_new ();
 
-        manager->presence = gsm_presence_new ();
-        g_signal_connect (manager->presence,
+        priv->presence = gsm_presence_new ();
+        g_signal_connect (priv->presence,
                           "status-changed",
                           G_CALLBACK (on_presence_status_changed),
                           manager);
 
-        g_settings_bind_with_mapping (manager->session_settings,
+        g_settings_bind_with_mapping (priv->session_settings,
                                       KEY_IDLE_DELAY,
-                                      manager->presence,
+                                      priv->presence,
                                       "idle-timeout",
                                       G_SETTINGS_BIND_GET,
                                       idle_timeout_get_mapping,
                                       NULL,
                                       NULL, NULL);
 
-        manager->system = gsm_get_system ();
-        manager->shell = gsm_get_shell ();
-        manager->end_session_cancellable = g_cancellable_new ();
+        priv->system = gsm_get_system ();
+        priv->shell = gsm_get_shell ();
+        priv->end_session_cancellable = g_cancellable_new ();
 }
 
 GsmManager *
@@ -2039,18 +3300,23 @@ gsm_manager_get (void)
 }
 
 GsmManager *
-gsm_manager_new (void)
+gsm_manager_new (GsmStore *client_store,
+                 gboolean  failsafe,
+                 gboolean  systemd_managed)
 {
         if (manager_object != NULL) {
                 g_object_ref (manager_object);
         } else {
                 gboolean res;
 
-                manager_object = g_object_new (GSM_TYPE_MANAGER, NULL);
+                manager_object = g_object_new (GSM_TYPE_MANAGER,
+                                               "client-store", client_store,
+                                               "failsafe", failsafe,
+                                               "systemd-managed", systemd_managed,
+                                               NULL);
 
                 g_object_add_weak_pointer (manager_object,
                                            (gpointer *) &manager_object);
-
                 res = register_manager (manager_object);
                 if (! res) {
                         g_object_unref (manager_object);
@@ -2064,16 +3330,37 @@ gsm_manager_new (void)
 static void
 disconnect_shell_dialog_signals (GsmManager *manager)
 {
-        g_clear_signal_handler (&manager->shell_end_session_dialog_canceled_id,
-                                manager->shell);
-        g_clear_signal_handler (&manager->shell_end_session_dialog_open_failed_id,
-                                manager->shell);
-        g_clear_signal_handler (&manager->shell_end_session_dialog_confirmed_logout_id,
-                                manager->shell);
-        g_clear_signal_handler (&manager->shell_end_session_dialog_confirmed_shutdown_id,
-                                manager->shell);
-        g_clear_signal_handler (&manager->shell_end_session_dialog_confirmed_reboot_id,
-                                manager->shell);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (priv->shell_end_session_dialog_canceled_id != 0) {
+                g_signal_handler_disconnect (priv->shell,
+                                             priv->shell_end_session_dialog_canceled_id);
+                priv->shell_end_session_dialog_canceled_id = 0;
+        }
+
+        if (priv->shell_end_session_dialog_confirmed_logout_id != 0) {
+                g_signal_handler_disconnect (priv->shell,
+                                             priv->shell_end_session_dialog_confirmed_logout_id);
+                priv->shell_end_session_dialog_confirmed_logout_id = 0;
+        }
+
+        if (priv->shell_end_session_dialog_confirmed_shutdown_id != 0) {
+                g_signal_handler_disconnect (priv->shell,
+                                             priv->shell_end_session_dialog_confirmed_shutdown_id);
+                priv->shell_end_session_dialog_confirmed_shutdown_id = 0;
+        }
+
+        if (priv->shell_end_session_dialog_confirmed_reboot_id != 0) {
+                g_signal_handler_disconnect (priv->shell,
+                                             priv->shell_end_session_dialog_confirmed_reboot_id);
+                priv->shell_end_session_dialog_confirmed_reboot_id = 0;
+        }
+
+        if (priv->shell_end_session_dialog_open_failed_id != 0) {
+                g_signal_handler_disconnect (priv->shell,
+                                             priv->shell_end_session_dialog_open_failed_id);
+                priv->shell_end_session_dialog_open_failed_id = 0;
+        }
 }
 
 static void
@@ -2085,20 +3372,27 @@ on_shell_end_session_dialog_canceled (GsmShell   *shell,
 }
 
 static void
-handle_end_session_dialog_confirmation (GsmManager           *manager,
-                                        GsmManagerLogoutType  logout_type)
-{
-        disconnect_shell_dialog_signals (manager);
-
-        if (manager->phase >= GSM_MANAGER_PHASE_END_SESSION)
-                return; /* Already logging out, nothing to do */
-
-        if (manager->logout_type != logout_type) {
-                g_warning ("GsmManager: Shell confirmed unexpected logout type");
-                return; /* Make it obvious that something went wrong */
+_handle_end_session_dialog_response (GsmManager           *manager,
+                                     GsmManagerLogoutType  logout_type)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        /* Note we're checking for END_SESSION here and
+         * QUERY_END_SESSION in the fallback cases elsewhere.
+         *
+         * That's because they run at different times in the logout
+         * process. The shell combines the inhibit and
+         * confirmation dialogs, so it gets displayed after we've collected
+         * inhibitors. The fallback code has two distinct dialogs, once of
+         * which we can (and do show) before collecting the inhibitors.
+         */
+        if (priv->phase >= GSM_MANAGER_PHASE_END_SESSION) {
+                /* Already shutting down, nothing more to do */
+                return;
         }
 
-        manager->logout_mode = GSM_MANAGER_LOGOUT_MODE_FORCE;
+        priv->logout_mode = GSM_MANAGER_LOGOUT_MODE_FORCE;
+        priv->logout_type = logout_type;
         end_phase (manager);
 }
 
@@ -2106,55 +3400,60 @@ static void
 on_shell_end_session_dialog_confirmed_logout (GsmShell   *shell,
                                               GsmManager *manager)
 {
-        handle_end_session_dialog_confirmation (manager, GSM_MANAGER_LOGOUT_LOGOUT);
+        _handle_end_session_dialog_response (manager, GSM_MANAGER_LOGOUT_LOGOUT);
+        disconnect_shell_dialog_signals (manager);
 }
 
 static void
 on_shell_end_session_dialog_confirmed_shutdown (GsmShell   *shell,
                                                 GsmManager *manager)
 {
-        handle_end_session_dialog_confirmation (manager, GSM_MANAGER_LOGOUT_SHUTDOWN);
+        _handle_end_session_dialog_response (manager, GSM_MANAGER_LOGOUT_SHUTDOWN);
+        disconnect_shell_dialog_signals (manager);
 }
 
 static void
 on_shell_end_session_dialog_confirmed_reboot (GsmShell   *shell,
                                               GsmManager *manager)
 {
-        handle_end_session_dialog_confirmation (manager, GSM_MANAGER_LOGOUT_REBOOT);
+        _handle_end_session_dialog_response (manager, GSM_MANAGER_LOGOUT_REBOOT);
+        disconnect_shell_dialog_signals (manager);
 }
 
 static void
 connect_shell_dialog_signals (GsmManager *manager)
 {
-        if (manager->shell_end_session_dialog_canceled_id != 0)
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (priv->shell_end_session_dialog_canceled_id != 0)
                 return;
 
-        manager->shell_end_session_dialog_canceled_id =
-                g_signal_connect (manager->shell,
+        priv->shell_end_session_dialog_canceled_id =
+                g_signal_connect (priv->shell,
                                   "end-session-dialog-canceled",
                                   G_CALLBACK (on_shell_end_session_dialog_canceled),
                                   manager);
 
-        manager->shell_end_session_dialog_open_failed_id =
-                g_signal_connect (manager->shell,
+        priv->shell_end_session_dialog_open_failed_id =
+                g_signal_connect (priv->shell,
                                   "end-session-dialog-open-failed",
                                   G_CALLBACK (on_shell_end_session_dialog_canceled),
                                   manager);
 
-        manager->shell_end_session_dialog_confirmed_logout_id =
-                g_signal_connect (manager->shell,
+        priv->shell_end_session_dialog_confirmed_logout_id =
+                g_signal_connect (priv->shell,
                                   "end-session-dialog-confirmed-logout",
                                   G_CALLBACK (on_shell_end_session_dialog_confirmed_logout),
                                   manager);
 
-        manager->shell_end_session_dialog_confirmed_shutdown_id =
-                g_signal_connect (manager->shell,
+        priv->shell_end_session_dialog_confirmed_shutdown_id =
+                g_signal_connect (priv->shell,
                                   "end-session-dialog-confirmed-shutdown",
                                   G_CALLBACK (on_shell_end_session_dialog_confirmed_shutdown),
                                   manager);
 
-        manager->shell_end_session_dialog_confirmed_reboot_id =
-                g_signal_connect (manager->shell,
+        priv->shell_end_session_dialog_confirmed_reboot_id =
+                g_signal_connect (priv->shell,
                                   "end-session-dialog-confirmed-reboot",
                                   G_CALLBACK (on_shell_end_session_dialog_confirmed_reboot),
                                   manager);
@@ -2164,14 +3463,15 @@ static void
 show_shell_end_session_dialog (GsmManager                   *manager,
                                GsmShellEndSessionDialogType  type)
 {
-        if (!gsm_shell_is_running (manager->shell))
-                return;
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
 
-        connect_shell_dialog_signals (manager);
+        if (!gsm_shell_is_running (priv->shell))
+                return;
 
-        gsm_shell_open_end_session_dialog (manager->shell,
+        gsm_shell_open_end_session_dialog (priv->shell,
                                            type,
-                                           manager->inhibitors);
+                                           priv->inhibitors);
+        connect_shell_dialog_signals (manager);
 }
 
 /*
@@ -2185,57 +3485,151 @@ gboolean
 gsm_manager_set_phase (GsmManager      *manager,
                        GsmManagerPhase  phase)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_return_val_if_fail (GSM_IS_MANAGER (manager), FALSE);
-        manager->phase = phase;
+        priv->phase = phase;
         return (TRUE);
 }
 
 static void
 append_app (GsmManager *manager,
-            GsmApp     *app)
+            GsmApp     *app,
+            gboolean    is_required)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        const char *id;
         const char *app_id;
         GsmApp     *dup;
 
+        id = gsm_app_peek_id (app);
+        if (IS_STRING_EMPTY (id)) {
+                g_debug ("GsmManager: not adding app: no id");
+                return;
+        }
+
+        dup = (GsmApp *)gsm_store_lookup (priv->apps, id);
+        if (dup != NULL) {
+                g_debug ("GsmManager: not adding app: already added");
+                return;
+        }
+
         app_id = gsm_app_peek_app_id (app);
         if (IS_STRING_EMPTY (app_id)) {
                 g_debug ("GsmManager: not adding app: no app-id");
                 return;
         }
 
-        dup = (GsmApp *) gsm_store_lookup (manager->apps, app_id);
+        dup = find_app_for_app_id (manager, app_id);
         if (dup != NULL) {
                 g_debug ("GsmManager: not adding app: app-id '%s' already exists", app_id);
+
+                if (is_required &&
+                    !g_slist_find (priv->required_apps, dup)) {
+                        g_debug ("GsmManager: making app '%s' required", gsm_app_peek_app_id (dup));
+                        priv->required_apps = g_slist_prepend (priv->required_apps, dup);
+                }
+
                 return;
         }
 
-        gsm_store_add (manager->apps, app_id, G_OBJECT (app));
+        gsm_store_add (priv->apps, id, G_OBJECT (app));
+        if (is_required) {
+                g_debug ("GsmManager: adding required app %s", gsm_app_peek_app_id (app));
+                priv->required_apps = g_slist_prepend (priv->required_apps, app);
+        }
 }
 
-gboolean
-gsm_manager_add_autostart_app (GsmManager *manager,
-                               const char *path)
+static gboolean
+add_autostart_app_internal (GsmManager *manager,
+                            const char *path,
+                            gboolean    is_required)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmApp  *app;
+        char   **internal_provides;
         GError *error = NULL;
 
         g_return_val_if_fail (GSM_IS_MANAGER (manager), FALSE);
         g_return_val_if_fail (path != NULL, FALSE);
 
-        app = gsm_app_new_for_path (path, &error);
+        /* Note: if we cannot add the app because its service is already
+         * provided, because its app-id is taken, or because of any other
+         * reason meaning there is already an app playing its role, then we
+         * should make sure that relevant properties (like
+         * provides/is_required) are set in the pre-existing app if needed. */
+        app = gsm_autostart_app_new (path, priv->systemd_managed, &error);
         if (app == NULL) {
                 g_warning ("%s", error->message);
                 g_clear_error (&error);
                 return FALSE;
         }
 
+        internal_provides = gsm_app_get_provides (app);
+        if (internal_provides) {
+                int i;
+                gboolean provided = FALSE;
+
+                for (i = 0; internal_provides[i] != NULL; i++) {
+                        GsmApp *dup;
+
+                        dup = (GsmApp *)gsm_store_find (priv->apps,
+                                                        (GsmStoreFunc)_find_app_provides,
+                                                        (char *)internal_provides[i]);
+                        if (dup != NULL) {
+                                g_debug ("GsmManager: service '%s' is already provided", internal_provides[i]);
+
+                                if (is_required &&
+                                    !g_slist_find (priv->required_apps, dup)) {
+                                        g_debug ("GsmManager: making app '%s' required", gsm_app_peek_app_id (dup));
+                                        priv->required_apps = g_slist_prepend (priv->required_apps, dup);
+                                }
+
+                                provided = TRUE;
+                                break;
+                        }
+                }
+
+                g_strfreev (internal_provides);
+
+                if (provided) {
+                        g_object_unref (app);
+                        return FALSE;
+                }
+        }
+
         g_debug ("GsmManager: read %s", path);
-        append_app (manager, app);
+        append_app (manager, app, is_required);
         g_object_unref (app);
 
         return TRUE;
 }
 
+gboolean
+gsm_manager_add_autostart_app (GsmManager *manager,
+                               const char *path)
+{
+        return add_autostart_app_internal (manager, path, FALSE);
+}
+
+/**
+ * gsm_manager_add_required_app:
+ * @manager: a #GsmManager
+ * @path: Path to desktop file
+ *
+ * Similar to gsm_manager_add_autostart_app(), except marks the
+ * component as being required; we then try harder to ensure
+ * it's running and inform the user if we can't.
+ *
+ */
+gboolean
+gsm_manager_add_required_app (GsmManager *manager,
+                              const char *path)
+{
+        return add_autostart_app_internal (manager, path, TRUE);
+}
+
+
 gboolean
 gsm_manager_add_autostart_apps_from_dir (GsmManager *manager,
                                          const char *path)
@@ -2275,17 +3669,19 @@ on_shutdown_prepared (GsmSystem  *system,
                       gboolean    success,
                       GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_debug ("GsmManager: on_shutdown_prepared, success: %d", success);
         g_signal_handlers_disconnect_by_func (system, on_shutdown_prepared, manager);
 
         if (success) {
                 /* move to end-session phase */
-                g_assert (manager->phase == GSM_MANAGER_PHASE_QUERY_END_SESSION);
-                manager->phase++;
+                g_assert (priv->phase == GSM_MANAGER_PHASE_QUERY_END_SESSION);
+                priv->phase++;
                 start_phase (manager);
         } else {
                 disconnect_shell_dialog_signals (manager);
-                gsm_shell_close_end_session_dialog (manager->shell);
+                gsm_shell_close_end_session_dialog (priv->shell);
                 /* back to running phase */
                 cancel_end_session (manager);
         }
@@ -2294,14 +3690,33 @@ on_shutdown_prepared (GsmSystem  *system,
 static gboolean
 do_query_end_session_exit (GsmManager *manager)
 {
-        if (manager->logout_type != GSM_MANAGER_LOGOUT_SHUTDOWN &&
-            manager->logout_type != GSM_MANAGER_LOGOUT_REBOOT)
-                return TRUE; /* Continue to end session phase */
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        gboolean reboot = FALSE;
+        gboolean shutdown = FALSE;
+
+        switch (priv->logout_type) {
+        case GSM_MANAGER_LOGOUT_LOGOUT:
+                break;
+        case GSM_MANAGER_LOGOUT_REBOOT:
+        case GSM_MANAGER_LOGOUT_REBOOT_INTERACT:
+                reboot = TRUE;
+                break;
+        case GSM_MANAGER_LOGOUT_SHUTDOWN:
+        case GSM_MANAGER_LOGOUT_SHUTDOWN_INTERACT:
+                shutdown = TRUE;
+                break;
+        default:
+                g_warning ("Unexpected logout type %d in do_query_end_session_exit()",
+                           priv->logout_type);
+                break;
+        }
 
-        g_signal_connect (manager->system, "shutdown-prepared",
-                          G_CALLBACK (on_shutdown_prepared), manager);
-        gsm_system_prepare_shutdown (manager->system,
-                                     manager->logout_type == GSM_MANAGER_LOGOUT_REBOOT);
+        if (reboot || shutdown) {
+                g_signal_connect (priv->system, "shutdown-prepared",
+                                  G_CALLBACK (on_shutdown_prepared), manager);
+                gsm_system_prepare_shutdown (priv->system, reboot);
+                return FALSE; /* don't leave query end session yet */
+        }
 
-        return FALSE; /* don't leave query end session yet */
+        return TRUE; /* go to end session phase */
 }
diff --git a/gnome-session/gsm-manager.h b/gnome-session/gsm-manager.h
index b358d2b5..3cfd8608 100644
--- a/gnome-session/gsm-manager.h
+++ b/gnome-session/gsm-manager.h
@@ -28,25 +28,41 @@
 
 G_BEGIN_DECLS
 
-/* UUIDs for log messages */
-#define GSM_MANAGER_STARTUP_SUCCEEDED_MSGID     "0ce153587afa4095832d233c17a88001"
-#define GSM_MANAGER_UNRECOVERABLE_FAILURE_MSGID "10dd2dc188b54a5e98970f56499d1f73"
-
 #define GSM_TYPE_MANAGER         (gsm_manager_get_type ())
-G_DECLARE_FINAL_TYPE (GsmManager, gsm_manager, GSM, MANAGER, GObject)
+G_DECLARE_DERIVABLE_TYPE (GsmManager, gsm_manager, GSM, MANAGER, GObject)
+
+struct _GsmManagerClass
+{
+        GObjectClass   parent_class;
+
+        void          (* phase_changed)       (GsmManager      *manager,
+                                               const char      *phase);
+};
 
 typedef enum {
-        /* We're waiting for systemd to start session services, the compositor, etc */
-        GSM_MANAGER_PHASE_INITIALIZATION = 0,
-        /* The session is running, but we're still launching the user's autostart apps */
+        /* gsm's own startup/initialization phase */
+        GSM_MANAGER_PHASE_STARTUP = 0,
+        /* gnome-initial-setup */
+        GSM_MANAGER_PHASE_EARLY_INITIALIZATION,
+        /* gnome-keyring-daemon */
+        GSM_MANAGER_PHASE_PRE_DISPLAY_SERVER,
+        /* wayland compositor and XWayland */
+        GSM_MANAGER_PHASE_DISPLAY_SERVER,
+        /* xrandr setup, gnome-settings-daemon, etc */
+        GSM_MANAGER_PHASE_INITIALIZATION,
+        /* window/compositing managers */
+        GSM_MANAGER_PHASE_WINDOW_MANAGER,
+        /* apps that will create _NET_WM_WINDOW_TYPE_PANEL windows */
+        GSM_MANAGER_PHASE_PANEL,
+        /* apps that will create _NET_WM_WINDOW_TYPE_DESKTOP windows */
+        GSM_MANAGER_PHASE_DESKTOP,
+        /* everything else */
         GSM_MANAGER_PHASE_APPLICATION,
-        /* The session is running */
+        /* done launching */
         GSM_MANAGER_PHASE_RUNNING,
-        /* Someone requested for the session to end,  */
+        /* shutting down */
         GSM_MANAGER_PHASE_QUERY_END_SESSION,
-        /* The session is shutting down */
         GSM_MANAGER_PHASE_END_SESSION,
-        /* The session has shut down, and gnome-session is about to exit */
         GSM_MANAGER_PHASE_EXIT
 } GsmManagerPhase;
 
@@ -65,13 +81,20 @@ typedef enum
 #define GSM_MANAGER_ERROR gsm_manager_error_quark ()
 GQuark              gsm_manager_error_quark                    (void);
 
-GsmManager *        gsm_manager_new                            (void);
+GsmManager *        gsm_manager_new                            (GsmStore       *client_store,
+                                                                gboolean        failsafe,
+                                                                gboolean        systemd_managed);
 GsmManager *        gsm_manager_get                            (void);
 
+
+gboolean            gsm_manager_get_failsafe                   (GsmManager     *manager);
 gboolean            gsm_manager_get_dbus_disconnected          (GsmManager *manager);
+gboolean            gsm_manager_get_systemd_managed            (GsmManager     *manager);
 
 gboolean            gsm_manager_add_autostart_app              (GsmManager     *manager,
                                                                 const char     *path);
+gboolean            gsm_manager_add_required_app               (GsmManager     *manager,
+                                                                const char     *path);
 gboolean            gsm_manager_add_autostart_apps_from_dir    (GsmManager     *manager,
                                                                 const char     *path);
 gboolean            gsm_manager_add_legacy_session_apps        (GsmManager     *manager,
@@ -79,8 +102,11 @@ gboolean            gsm_manager_add_legacy_session_apps        (GsmManager     *
 
 void                gsm_manager_start                          (GsmManager     *manager);
 
+char *              _gsm_manager_get_default_session           (GsmManager     *manager);
+
 void                _gsm_manager_set_active_session            (GsmManager     *manager,
-                                                                const char     *session_name);
+                                                                const char     *session_name,
+                                                                gboolean        is_fallback);
 
 gboolean            gsm_manager_logout                         (GsmManager     *manager,
                                                                 guint           logout_mode,
@@ -89,8 +115,6 @@ gboolean            gsm_manager_logout                         (GsmManager     *
 gboolean            gsm_manager_set_phase                      (GsmManager     *manager,
                                                                 GsmManagerPhase phase);
 
-void                gsm_quit                                   (void);
-
 G_END_DECLS
 
 #endif /* __GSM_MANAGER_H */
diff --git a/gnome-session/gsm-process-helper.c b/gnome-session/gsm-process-helper.c
new file mode 100644
index 00000000..32f26c8d
--- /dev/null
+++ b/gnome-session/gsm-process-helper.c
@@ -0,0 +1,113 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2010 Novell, Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <config.h>
+
+#include <gio/gio.h>
+#include <glib/gi18n.h>
+
+#include "gsm-process-helper.h"
+
+typedef struct {
+        gboolean        done;
+        GSubprocess    *process;
+        gboolean        caught_error;
+        GError        **error;
+        GMainContext   *maincontext;
+        GSource        *timeout_source;
+} GsmProcessHelper;
+
+static void
+on_child_exited (GObject        *source,
+                 GAsyncResult   *result,
+                 gpointer        data)
+{
+        GsmProcessHelper *helper = data;
+
+        helper->done = TRUE;
+
+        if (!g_subprocess_wait_check_finish ((GSubprocess*)source, result,
+                                             helper->caught_error ? NULL : helper->error))
+                helper->caught_error = TRUE;
+
+        g_clear_pointer (&helper->timeout_source, g_source_destroy);
+
+        g_main_context_wakeup (helper->maincontext);
+}
+
+static gboolean
+on_child_timeout (gpointer data)
+{
+        GsmProcessHelper *helper = data;
+        
+        g_assert (!helper->done);
+        
+        g_subprocess_force_exit (helper->process);
+        
+        g_set_error_literal (helper->error,
+                             G_IO_CHANNEL_ERROR,
+                             G_IO_CHANNEL_ERROR_FAILED,
+                             "Timed out");
+
+        helper->timeout_source = NULL;
+        
+        return FALSE;
+}
+
+gboolean
+gsm_process_helper (const char   *command_line,
+                    unsigned int  timeout,
+                    GError      **error)
+{
+        gboolean ret = FALSE;
+        GsmProcessHelper helper = { 0, };
+        gchar **argv = NULL;
+        GMainContext *subcontext = NULL;
+
+        if (!g_shell_parse_argv (command_line, NULL, &argv, error))
+                goto out;
+
+        helper.error = error;
+
+        subcontext = g_main_context_new ();
+        g_main_context_push_thread_default (subcontext);
+
+        helper.process = g_subprocess_newv ((const char*const*)argv, 0, error);
+        if (!helper.process)
+                goto out;
+
+        g_subprocess_wait_async (helper.process, NULL, on_child_exited, &helper);
+
+        helper.timeout_source = g_timeout_source_new (timeout);
+
+        g_source_set_callback (helper.timeout_source, on_child_timeout, &helper, NULL);
+        g_source_attach (helper.timeout_source, subcontext);
+
+        while (!helper.done)
+                g_main_context_iteration (subcontext, TRUE);
+
+        ret = helper.caught_error;
+ out:
+        g_strfreev (argv);
+        if (subcontext) {
+                g_main_context_pop_thread_default (subcontext);
+                g_main_context_unref (subcontext);
+        }
+        g_clear_object (&helper.process);
+        return ret;
+}
diff --git a/gnome-session/gsm-process-helper.h b/gnome-session/gsm-process-helper.h
new file mode 100644
index 00000000..4ca55a95
--- /dev/null
+++ b/gnome-session/gsm-process-helper.h
@@ -0,0 +1,32 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2010 Novell, Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __GSM_PROCESS_HELPER_H
+#define __GSM_PROCESS_HELPER_H
+
+#include <glib.h>
+
+G_BEGIN_DECLS
+
+int  gsm_process_helper (const char    *command_line,
+                         unsigned int   timeout,
+                         GError       **error);
+
+G_END_DECLS
+
+#endif /* __GSM_PROCESS_HELPER_H */
